Index: branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/HeuristicLab.OptimizationExpertSystem-3.3.csproj
===================================================================
--- branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/HeuristicLab.OptimizationExpertSystem-3.3.csproj	(revision 13745)
+++ branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/HeuristicLab.OptimizationExpertSystem-3.3.csproj	(revision 13748)
@@ -191,4 +191,6 @@
       <DependentUpon>AlgorithmControlForm.cs</DependentUpon>
     </Compile>
+    <Compile Include="Toolbar\DownloadFromOKBToolbarItem.cs" />
+    <Compile Include="Toolbar\ToolbarItemBase.cs" />
     <Compile Include="Views\KnowledgeCenterAllinOneView.cs">
       <SubType>UserControl</SubType>
Index: branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/0_Config/30_DownloadFromOkbMenuItem.cs
===================================================================
--- branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/0_Config/30_DownloadFromOkbMenuItem.cs	(revision 13745)
+++ branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/0_Config/30_DownloadFromOkbMenuItem.cs	(revision 13748)
@@ -20,5 +20,7 @@
 #endregion
 
+using HeuristicLab.Common;
 using HeuristicLab.Common.Resources;
+using HeuristicLab.MainForm;
 using System;
 using System.Collections.Generic;
@@ -41,5 +43,10 @@
     }
 
-    public override string ToolTipText { get { return "Download relevant runs from the knowledge base."; } }
+    public override string ToolTipText {
+      get {
+        return @"Download relevant runs, including algorithm instances
+and problem instances from the OKB server.";
+      }
+    }
 
     public override void Execute() {
@@ -51,4 +58,5 @@
       ToolStripItem.Enabled = MainForm.ExpertSystem.Problem.ProblemId != -1;
       MainForm.ExpertSystem.Problem.ProblemChanged += OnProblemChanged;
+      MainForm.ExpertSystem.DownloadStarted += OnDownloadStarted;
     }
 
@@ -56,4 +64,17 @@
       ToolStripItem.Enabled = MainForm.ExpertSystem.Problem.ProblemId != -1;
     }
+
+    private void OnDownloadStarted(object sender, EventArgs<IProgress> e) {
+      ToolStripItem.Enabled = false;
+      e.Value.ProgressStateChanged += DownloadProgressOnStateChanged;
+    }
+
+    private void DownloadProgressOnStateChanged(object sender, EventArgs eventArgs) {
+      var progress = (IProgress)sender;
+      if (progress.ProgressState == ProgressState.Finished || progress.ProgressState == ProgressState.Canceled) {
+        ToolStripItem.Enabled = true;
+        progress.ProgressStateChanged -= DownloadProgressOnStateChanged;
+      }
+    }
   }
 }
Index: branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/OptimizationKnowledgeCenter.cs
===================================================================
--- branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/OptimizationKnowledgeCenter.cs	(revision 13745)
+++ branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/OptimizationKnowledgeCenter.cs	(revision 13748)
@@ -42,4 +42,5 @@
 
     private void ExpertSystemOnDownloadStarted(object sender, EventArgs<IProgress> e) {
+      if (InvokeRequired) { Invoke((Action<object, EventArgs<IProgress>>)ExpertSystemOnDownloadStarted, sender, e); return; }
       e.Value.ProgressStateChanged += OnProgressStateChanged;
       e.Value.ProgressValueChanged += OnProgressValueChanged;
@@ -52,4 +53,5 @@
 
     private void OnProgressStateChanged(object sender, EventArgs e) {
+      if (InvokeRequired) { Invoke((Action<object, EventArgs>)OnProgressStateChanged, sender, e); return; }
       var progress = (IProgress)sender;
       if (progress.ProgressState == ProgressState.Canceled
@@ -64,4 +66,5 @@
 
     private void OnProgressValueChanged(object sender, EventArgs e) {
+      if (InvokeRequired) { Invoke((Action<object, EventArgs>)OnProgressValueChanged, sender, e); return; }
       var progress = (IProgress)sender;
       progressBar.Value = Math.Max(progressBar.Minimum, Math.Min(progressBar.Maximum, (int)(progress.ProgressValue * 100)));
@@ -69,4 +72,5 @@
 
     private void OnProgressStatusChanged(object sender, EventArgs e) {
+      if (InvokeRequired) { Invoke((Action<object, EventArgs>)OnProgressStatusChanged, sender, e); return; }
       var progress = (IProgress)sender;
       progressLabel.Text = progress.Status.Replace(Environment.NewLine, "   ");
Index: branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Toolbar/DownloadFromOKBToolbarItem.cs
===================================================================
--- branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Toolbar/DownloadFromOKBToolbarItem.cs	(revision 13748)
+++ branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Toolbar/DownloadFromOKBToolbarItem.cs	(revision 13748)
@@ -0,0 +1,74 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.MainForm;
+using System;
+using System.Drawing;
+
+namespace HeuristicLab.OptimizationExpertSystem.Toolbar {
+  internal class DownloadFromOKBToolbarItem : ToolbarItemBase {
+    public override string Name {
+      get { return "Download"; }
+    }
+
+    public override string ToolTipText {
+      get { return @"Download relevant runs, including algorithm instances
+and problem instances from the OKB server."; }
+    }
+
+    public override int Position {
+      get { return 10; }
+    }
+
+    public override Image Image {
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.ArrowDown; }
+    }
+
+    public override void Execute() {
+      MainForm.ExpertSystem.UpdateKnowledgeBaseAsync();
+    }
+
+    protected override void OnToolStripItemSet(EventArgs e) {
+      base.OnToolStripItemSet(e);
+      ToolStripItem.Enabled = MainForm.ExpertSystem.Problem.ProblemId != -1;
+      MainForm.ExpertSystem.Problem.ProblemChanged += OnProblemChanged;
+      MainForm.ExpertSystem.DownloadStarted += OnDownloadStarted;
+    }
+
+    private void OnProblemChanged(object sender, EventArgs e) {
+      ToolStripItem.Enabled = MainForm.ExpertSystem.Problem.ProblemId != -1;
+    }
+
+    private void OnDownloadStarted(object sender, EventArgs<IProgress> e) {
+      ToolStripItem.Enabled = false;
+      e.Value.ProgressStateChanged += DownloadProgressOnStateChanged;
+    }
+
+    private void DownloadProgressOnStateChanged(object sender, EventArgs eventArgs) {
+      var progress = (IProgress)sender;
+      if (progress.ProgressState == ProgressState.Finished || progress.ProgressState == ProgressState.Canceled) {
+        ToolStripItem.Enabled = true;
+        progress.ProgressStateChanged -= DownloadProgressOnStateChanged;
+      }
+    }
+  }
+}
Index: branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Toolbar/ToolbarItemBase.cs
===================================================================
--- branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Toolbar/ToolbarItemBase.cs	(revision 13748)
+++ branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Toolbar/ToolbarItemBase.cs	(revision 13748)
@@ -0,0 +1,30 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.MainForm.WindowsForms;
+
+namespace HeuristicLab.OptimizationExpertSystem.Toolbar {
+  internal abstract class ToolbarItemBase : ToolBarItem, IOptimizationKnowledgeCenterUi {
+    public OptimizationKnowledgeCenter MainForm {
+      get { return (OptimizationKnowledgeCenter)HeuristicLab.MainForm.MainFormManager.MainForm; }
+    }
+  }
+}