Index: branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem.Common/3.3/KnowledgeCenter.cs
===================================================================
--- branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem.Common/3.3/KnowledgeCenter.cs	(revision 13750)
+++ branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem.Common/3.3/KnowledgeCenter.cs	(revision 13751)
@@ -53,46 +53,51 @@
     }
 
-    private IntValue maximumEvaluations;
+    private readonly IntValue maximumEvaluations;
     public IntValue MaximumEvaluations {
       get { return maximumEvaluations; }
     }
 
-    private RunCollection instanceRuns;
+    private readonly RunCollection instanceRuns;
     public RunCollection InstanceRuns {
       get { return instanceRuns; }
     }
 
-    private RunCollection seededRuns;
+    private readonly RunCollection seededRuns;
     public RunCollection SeededRuns {
       get { return seededRuns; }
     }
 
-    private RunCollection knowledgeBase;
+    private readonly RunCollection knowledgeBase;
     public RunCollection KnowledgeBase {
       get { return knowledgeBase; }
     }
 
-    private SingleObjectiveOKBProblem problem;
+    private readonly SingleObjectiveOKBProblem problem;
     public SingleObjectiveOKBProblem Problem {
       get { return problem; }
     }
 
-    private ItemList<IAlgorithm> suggestedInstances;
-    private ReadOnlyItemList<IAlgorithm> readOnlySuggestedInstances;
+    private readonly ItemList<IAlgorithm> suggestedInstances;
+    private readonly ReadOnlyItemList<IAlgorithm> readOnlySuggestedInstances;
     public ReadOnlyItemList<IAlgorithm> SuggestedInstances {
       get { return readOnlySuggestedInstances; }
     }
 
-    private RunCollection problemInstances;
+    private readonly RunCollection problemInstances;
     public RunCollection ProblemInstances {
       get { return problemInstances; }
     }
 
-    private CheckedItemList<IScope> solutionSeedingPool;
+    private readonly CheckedItemList<StringValue> problemCharacteristics;
+    public CheckedItemList<StringValue> ProblemCharacteristics {
+      get { return problemCharacteristics; }
+    } 
+
+    private readonly CheckedItemList<IScope> solutionSeedingPool;
     public CheckedItemList<IScope> SolutionSeedingPool {
       get { return solutionSeedingPool; }
     }
 
-    private EnumValue<SeedingStrategyTypes> seedingStrategy;
+    private readonly EnumValue<SeedingStrategyTypes> seedingStrategy;
     public EnumValue<SeedingStrategyTypes> SeedingStrategy {
       get { return seedingStrategy; }
@@ -101,7 +106,6 @@
     private BidirectionalLookup<long, IRun> algorithmId2RunMapping;
     private BidirectionalDictionary<long, IAlgorithm> algorithmId2AlgorithmInstanceMapping;
-
-    private Run currentInstance;
-
+    private BidirectionalDictionary<long, IRun> problemId2ProblemInstanceMapping;
+    
     private bool Maximization {
       get { return Problem != null && Problem.ProblemId >= 0 && ((IValueParameter<BoolValue>)Problem.MaximizationParameter).Value.Value; }
@@ -116,7 +120,9 @@
       readOnlySuggestedInstances = suggestedInstances.AsReadOnly();
       problemInstances = new RunCollection();
+      problemCharacteristics = new CheckedItemList<StringValue>();
       problem = new SingleObjectiveOKBProblem();
       algorithmId2RunMapping = new BidirectionalLookup<long, IRun>();
       algorithmId2AlgorithmInstanceMapping = new BidirectionalDictionary<long, IAlgorithm>();
+      problemId2ProblemInstanceMapping = new BidirectionalDictionary<long, IRun>();
       solutionSeedingPool = new CheckedItemList<IScope>();
       seedingStrategy = new EnumValue<SeedingStrategyTypes>(SeedingStrategyTypes.NoSeeding);
@@ -162,34 +168,24 @@
     }
 
-    private void UpdateInstanceProjection() {
-      currentInstance = null;
-      var filter = new HashSet<string>();
-
-      if (Problem.ProblemId != -1) {
-        currentInstance = new Run { Name = Problem.Name };
-        Problem.Problem.CollectParameterValues(currentInstance.Parameters);
-        foreach (var c in RunCreationClient.Instance.GetCharacteristicValues(Problem.ProblemId)) {
-          var key = "Characteristic." + c.Name;
-          currentInstance.Results.Add(key, RunCreationClient.Instance.ConvertToItem(c));
-          filter.Add(key);
-        }
-      }
-      // TODO: There is a problem with missing values that has to be solved
-      // The common set of characteristics among all problems may be too small to be useful
-      // It has to be decided somehow which problem instances to include in order to obtain the set of features that is expressive and available
-      var allCharacteristics = ProblemInstances.Select(x => new HashSet<string>(x.Results.Where(y => y.Key.StartsWith("Characteristic.", StringComparison.Ordinal)).Select(y => y.Key))).ToList();
-      if (allCharacteristics.Count == 0) return;
-
-      var commonCharacteristics = filter.Count > 0 ? filter : allCharacteristics[0];
-      for (var i = 0; i < allCharacteristics.Count; i++)
-        commonCharacteristics.IntersectWith(allCharacteristics[i]);
-
-      if (commonCharacteristics.Count == 0) return;
-
-      var instances = new Dictionary<string, double[]>();
-      foreach (var i in ProblemInstances)
-        instances[i.Name] = i.Results.Where(x => commonCharacteristics.Contains(x.Key)).OrderBy(x => x.Key).Select(x => (double)((dynamic)x.Value).Value).ToArray();
-      if (currentInstance != null)
-        instances[currentInstance.Name] = currentInstance.Results.Where(x => commonCharacteristics.Contains(x.Key)).OrderBy(x => x.Key).Select(x => (double)((dynamic)x.Value).Value).ToArray();
+    public bool IsCurrentInstance(IRun run) {
+      if (!problemId2ProblemInstanceMapping.ContainsSecond(run)) return false;
+      return problemId2ProblemInstanceMapping.GetBySecond(run) == Problem.ProblemId;
+    }
+
+    public void UpdateInstanceProjection() {
+      if (ProblemCharacteristics.Count == 0) return;
+
+      var instances = new Dictionary<IRun, double[]>();
+      foreach (var run in ProblemInstances) {
+        var f = 0;
+        instances[run] = new double[ProblemCharacteristics.CheckedItems.Count()];
+        foreach (var c in ProblemCharacteristics.CheckedItems.Select(x => x.Value.Value)) {
+          IItem item;
+          if (run.Results.TryGetValue(c, out item)) {
+            instances[run][f] = (double)((dynamic)item).Value;
+          } else instances[run][f] = 0; // TODO: handle missing values
+          f++;
+        }
+      }
 
       var allValues = instances.SelectMany(x => x.Value).ToList();
@@ -205,5 +201,5 @@
       }
 
-      var key2Idx = new BidirectionalDictionary<string, int>();
+      var key2Idx = new BidirectionalDictionary<IRun, int>();
       foreach (var kvp in instances.Select((k, i) => new { Index = i, Key = k.Key }))
         key2Idx.Add(kvp.Key, kvp.Index);
@@ -222,5 +218,5 @@
       #endregion
       #region PCA
-      var ds = new double[instances.Count, commonCharacteristics.Count];
+      var ds = new double[instances.Count, ProblemCharacteristics.CheckedItems.Count()];
       foreach (var instance in instances) {
         var arr = instance.Value;
@@ -235,5 +231,5 @@
       #endregion
       #region SOM
-      var features = new DoubleMatrix(commonCharacteristics.Count, instances.Count);
+      var features = new DoubleMatrix(ProblemCharacteristics.CheckedItems.Count(), instances.Count);
       foreach (var instance in instances) {
         var arr = instance.Value;
@@ -241,5 +237,5 @@
           features[feature, key2Idx.GetByFirst(instance.Key)] = arr[feature];
       }
-      var somCoords = SOM.Map(features, new MersenneTwister(42), somSize: 20, learningRadius: 20, jittering: true);
+      var somCoords = SOM.Map(features, new MersenneTwister(42), somSize: 20, learningRadius: 20, iterations: 200, jittering: true);
       #endregion
 
@@ -249,6 +245,6 @@
           double x = 0, y = 0;
           for (var feature = 0; feature < ds.GetLength(1); feature++) {
-            x += ds[key2Idx.GetByFirst(instance.Name), feature] * v[feature, 0];
-            y += ds[key2Idx.GetByFirst(instance.Name), feature] * v[feature, 1];
+            x += ds[key2Idx.GetByFirst(instance), feature] * v[feature, 0];
+            y += ds[key2Idx.GetByFirst(instance), feature] * v[feature, 1];
           }
 
@@ -262,52 +258,18 @@
 
           if (instance.Results.TryGetValue("Projection.MDS.X", out item)) {
-            ((DoubleValue)item).Value = coords[key2Idx.GetByFirst(instance.Name), 0];
-          } else instance.Results.Add("Projection.MDS.X", new DoubleValue(coords[key2Idx.GetByFirst(instance.Name), 0]));
+            ((DoubleValue)item).Value = coords[key2Idx.GetByFirst(instance), 0];
+          } else instance.Results.Add("Projection.MDS.X", new DoubleValue(coords[key2Idx.GetByFirst(instance), 0]));
           if (instance.Results.TryGetValue("Projection.MDS.Y", out item)) {
-            ((DoubleValue)item).Value = coords[key2Idx.GetByFirst(instance.Name), 1];
-          } else instance.Results.Add("Projection.MDS.Y", new DoubleValue(coords[key2Idx.GetByFirst(instance.Name), 1]));
+            ((DoubleValue)item).Value = coords[key2Idx.GetByFirst(instance), 1];
+          } else instance.Results.Add("Projection.MDS.Y", new DoubleValue(coords[key2Idx.GetByFirst(instance), 1]));
 
           if (instance.Results.TryGetValue("Projection.SOM.X", out item)) {
-            ((DoubleValue)item).Value = somCoords[key2Idx.GetByFirst(instance.Name), 0];
-          } else instance.Results.Add("Projection.SOM.X", new DoubleValue(somCoords[key2Idx.GetByFirst(instance.Name), 0]));
+            ((DoubleValue)item).Value = somCoords[key2Idx.GetByFirst(instance), 0];
+          } else instance.Results.Add("Projection.SOM.X", new DoubleValue(somCoords[key2Idx.GetByFirst(instance), 0]));
           if (instance.Results.TryGetValue("Projection.SOM.Y", out item)) {
-            ((DoubleValue)item).Value = somCoords[key2Idx.GetByFirst(instance.Name), 1];
-          } else instance.Results.Add("Projection.SOM.Y", new DoubleValue(somCoords[key2Idx.GetByFirst(instance.Name), 1]));
+            ((DoubleValue)item).Value = somCoords[key2Idx.GetByFirst(instance), 1];
+          } else instance.Results.Add("Projection.SOM.Y", new DoubleValue(somCoords[key2Idx.GetByFirst(instance), 1]));
         }
       } finally { ProblemInstances.UpdateOfRunsInProgress = false; }
-
-      if (currentInstance != null) {
-        double x = 0, y = 0;
-        for (var feature = 0; feature < ds.GetLength(1); feature++) {
-          x += ds[key2Idx.GetByFirst(currentInstance.Name), feature] * v[feature, 0];
-          y += ds[key2Idx.GetByFirst(currentInstance.Name), feature] * v[feature, 1];
-        }
-
-        IItem item;
-        if (currentInstance.Results.TryGetValue("Projection.PCA.X", out item)) {
-          ((DoubleValue)item).Value = x;
-        } else currentInstance.Results.Add("Projection.PCA.X", new DoubleValue(x));
-        if (currentInstance.Results.TryGetValue("Projection.PCA.Y", out item)) {
-          ((DoubleValue)item).Value = y;
-        } else currentInstance.Results.Add("Projection.PCA.Y", new DoubleValue(y));
-
-        if (currentInstance.Results.TryGetValue("Projection.MDS.X", out item)) {
-          ((DoubleValue)item).Value = coords[key2Idx.GetByFirst(currentInstance.Name), 0];
-        } else currentInstance.Results.Add("Projection.MDS.X", new DoubleValue(coords[key2Idx.GetByFirst(currentInstance.Name), 0]));
-        if (currentInstance.Results.TryGetValue("Projection.MDS.Y", out item)) {
-          ((DoubleValue)item).Value = coords[key2Idx.GetByFirst(currentInstance.Name), 1];
-        } else currentInstance.Results.Add("Projection.MDS.Y", new DoubleValue(coords[key2Idx.GetByFirst(currentInstance.Name), 1]));
-      }
-    }
-
-    public Tuple<double, double> ProjectCurrentInstance(string projection) {
-      if (currentInstance == null) return null;
-      var xKey = "Projection." + projection + ".X";
-      var yKey = "Projection." + projection + ".Y";
-      if (!currentInstance.Results.ContainsKey(xKey) || !currentInstance.Results.ContainsKey(yKey))
-        return null;
-      var x = ((DoubleValue)currentInstance.Results[xKey]).Value;
-      var y = ((DoubleValue)currentInstance.Results[yKey]).Value;
-      return Tuple.Create(x, y);
     }
 
@@ -455,4 +417,5 @@
         ProblemInstances.UpdateOfRunsInProgress = true;
         ProblemInstances.Clear();
+        var characteristics = new HashSet<string>();
         var totalProblems = adminClient.Problems.Count(x => x.ProblemClassId == probClassId);
         foreach (var problInst in adminClient.Problems.Where(x => x.ProblemClassId == probClassId)) {
@@ -470,6 +433,8 @@
                 foreach (var v in RunCreationClient.Instance.GetCharacteristicValues(problInst.Id)) {
                   probRun.Results.Add("Characteristic." + v.Name, RunCreationClient.Instance.ConvertToItem(v));
+                  characteristics.Add(v.Name);
                 }
                 ProblemInstances.Add(probRun);
+                problemId2ProblemInstanceMapping.Add(problInst.Id, probRun);
               } catch { }
               stream.Close();
@@ -561,4 +526,5 @@
               var result = ExpectedRuntimeHelper.CalculateErt(kvp.Value, "QualityPerEvaluations", bkQuality * target, maximization);
               var resultName = kvp.Key + "@" + ((target - 1) * 100) + "%";
+              characteristics.Add(resultName);
               IItem item;
               if (instance.Results.TryGetValue(resultName, out item)) {
@@ -568,4 +534,5 @@
           }
         }
+        ProblemCharacteristics.Replace(characteristics.Select(x => new StringValue(x)));
         try {
           KnowledgeBase.UpdateOfRunsInProgress = true;
Index: branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Views/KnowledgeCenterAllinOneView.cs
===================================================================
--- branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Views/KnowledgeCenterAllinOneView.cs	(revision 13750)
+++ branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Views/KnowledgeCenterAllinOneView.cs	(revision 13751)
@@ -271,13 +271,6 @@
           Label = run.Name
         };
-        instancesSeries.Points.Add(dataPoint);
-      }
-
-      var curPoint = Content.ProjectCurrentInstance(projection);
-      if (curPoint != null) {
-        var dp = new DataPoint(curPoint.Item1, curPoint.Item2) {
-          Label = Content.Problem.Problem.Name
-        };
-        currentInstanceSeries.Points.Add(dp);
+        if (!Content.IsCurrentInstance(run)) instancesSeries.Points.Add(dataPoint);
+        else currentInstanceSeries.Points.Add(dataPoint);
       }
     }
Index: branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Views/UnderstandingProblemInstanceView.Designer.cs
===================================================================
--- branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Views/UnderstandingProblemInstanceView.Designer.cs	(revision 13750)
+++ branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Views/UnderstandingProblemInstanceView.Designer.cs	(revision 13751)
@@ -50,35 +50,24 @@
       System.Windows.Forms.DataVisualization.Charting.Series series1 = new System.Windows.Forms.DataVisualization.Charting.Series();
       System.Windows.Forms.DataVisualization.Charting.Series series2 = new System.Windows.Forms.DataVisualization.Charting.Series();
-      this.projectionLabel = new System.Windows.Forms.Label();
-      this.projectionComboBox = new System.Windows.Forms.ComboBox();
       this.problemInstancesTabControl = new HeuristicLab.MainForm.WindowsForms.DragOverTabControl();
       this.mapTabPage = new System.Windows.Forms.TabPage();
-      this.instanceMapChart = new HeuristicLab.Visualization.ChartControlsExtensions.EnhancedChart();
       this.instancesTabPage = new System.Windows.Forms.TabPage();
       this.problemInstancesView = new HeuristicLab.MainForm.WindowsForms.ViewHost();
+      this.mapSplitContainer = new System.Windows.Forms.SplitContainer();
+      this.invPropCheckBox = new System.Windows.Forms.CheckBox();
+      this.sizeLabel = new System.Windows.Forms.Label();
+      this.projectionLabel = new System.Windows.Forms.Label();
+      this.instanceMapChart = new HeuristicLab.Visualization.ChartControlsExtensions.EnhancedChart();
+      this.sizeComboBox = new System.Windows.Forms.ComboBox();
+      this.projectionComboBox = new System.Windows.Forms.ComboBox();
+      this.showCharacteristicsCheckBox = new System.Windows.Forms.CheckBox();
       this.problemInstancesTabControl.SuspendLayout();
       this.mapTabPage.SuspendLayout();
+      this.instancesTabPage.SuspendLayout();
+      ((System.ComponentModel.ISupportInitialize)(this.mapSplitContainer)).BeginInit();
+      this.mapSplitContainer.Panel1.SuspendLayout();
+      this.mapSplitContainer.SuspendLayout();
       ((System.ComponentModel.ISupportInitialize)(this.instanceMapChart)).BeginInit();
-      this.instancesTabPage.SuspendLayout();
       this.SuspendLayout();
-      // 
-      // projectionLabel
-      // 
-      this.projectionLabel.AutoSize = true;
-      this.projectionLabel.Location = new System.Drawing.Point(6, 9);
-      this.projectionLabel.Name = "projectionLabel";
-      this.projectionLabel.Size = new System.Drawing.Size(57, 13);
-      this.projectionLabel.TabIndex = 10;
-      this.projectionLabel.Text = "Projection:";
-      // 
-      // projectionComboBox
-      // 
-      this.projectionComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
-      this.projectionComboBox.FormattingEnabled = true;
-      this.projectionComboBox.Location = new System.Drawing.Point(69, 6);
-      this.projectionComboBox.Name = "projectionComboBox";
-      this.projectionComboBox.Size = new System.Drawing.Size(158, 21);
-      this.projectionComboBox.TabIndex = 9;
-      this.projectionComboBox.SelectedIndexChanged += new System.EventHandler(this.ProjectionComboBoxOnSelectedIndexChanged);
       // 
       // problemInstancesTabControl
@@ -98,7 +87,5 @@
       // mapTabPage
       // 
-      this.mapTabPage.Controls.Add(this.projectionLabel);
-      this.mapTabPage.Controls.Add(this.instanceMapChart);
-      this.mapTabPage.Controls.Add(this.projectionComboBox);
+      this.mapTabPage.Controls.Add(this.mapSplitContainer);
       this.mapTabPage.Location = new System.Drawing.Point(4, 22);
       this.mapTabPage.Name = "mapTabPage";
@@ -108,4 +95,80 @@
       this.mapTabPage.Text = "Map";
       this.mapTabPage.UseVisualStyleBackColor = true;
+      // 
+      // instancesTabPage
+      // 
+      this.instancesTabPage.Controls.Add(this.problemInstancesView);
+      this.instancesTabPage.Location = new System.Drawing.Point(4, 22);
+      this.instancesTabPage.Name = "instancesTabPage";
+      this.instancesTabPage.Padding = new System.Windows.Forms.Padding(3);
+      this.instancesTabPage.Size = new System.Drawing.Size(992, 734);
+      this.instancesTabPage.TabIndex = 0;
+      this.instancesTabPage.Text = "Instances";
+      this.instancesTabPage.UseVisualStyleBackColor = true;
+      // 
+      // problemInstancesView
+      // 
+      this.problemInstancesView.Caption = "View";
+      this.problemInstancesView.Content = null;
+      this.problemInstancesView.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.problemInstancesView.Enabled = false;
+      this.problemInstancesView.Location = new System.Drawing.Point(3, 3);
+      this.problemInstancesView.Name = "problemInstancesView";
+      this.problemInstancesView.ReadOnly = false;
+      this.problemInstancesView.Size = new System.Drawing.Size(986, 728);
+      this.problemInstancesView.TabIndex = 0;
+      this.problemInstancesView.ViewsLabelVisible = true;
+      this.problemInstancesView.ViewType = null;
+      // 
+      // mapSplitContainer
+      // 
+      this.mapSplitContainer.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.mapSplitContainer.FixedPanel = System.Windows.Forms.FixedPanel.Panel2;
+      this.mapSplitContainer.Location = new System.Drawing.Point(3, 3);
+      this.mapSplitContainer.Name = "mapSplitContainer";
+      // 
+      // mapSplitContainer.Panel1
+      // 
+      this.mapSplitContainer.Panel1.Controls.Add(this.showCharacteristicsCheckBox);
+      this.mapSplitContainer.Panel1.Controls.Add(this.invPropCheckBox);
+      this.mapSplitContainer.Panel1.Controls.Add(this.sizeLabel);
+      this.mapSplitContainer.Panel1.Controls.Add(this.projectionLabel);
+      this.mapSplitContainer.Panel1.Controls.Add(this.instanceMapChart);
+      this.mapSplitContainer.Panel1.Controls.Add(this.sizeComboBox);
+      this.mapSplitContainer.Panel1.Controls.Add(this.projectionComboBox);
+      this.mapSplitContainer.Panel1.Padding = new System.Windows.Forms.Padding(0, 3, 0, 0);
+      this.mapSplitContainer.Size = new System.Drawing.Size(986, 728);
+      this.mapSplitContainer.SplitterDistance = 847;
+      this.mapSplitContainer.TabIndex = 12;
+      // 
+      // invPropCheckBox
+      // 
+      this.invPropCheckBox.AutoSize = true;
+      this.invPropCheckBox.Checked = true;
+      this.invPropCheckBox.CheckState = System.Windows.Forms.CheckState.Checked;
+      this.invPropCheckBox.Location = new System.Drawing.Point(579, 12);
+      this.invPropCheckBox.Name = "invPropCheckBox";
+      this.invPropCheckBox.Size = new System.Drawing.Size(118, 17);
+      this.invPropCheckBox.TabIndex = 17;
+      this.invPropCheckBox.Text = "inverse proportional";
+      this.invPropCheckBox.UseVisualStyleBackColor = true;
+      // 
+      // sizeLabel
+      // 
+      this.sizeLabel.AutoSize = true;
+      this.sizeLabel.Location = new System.Drawing.Point(264, 12);
+      this.sizeLabel.Name = "sizeLabel";
+      this.sizeLabel.Size = new System.Drawing.Size(30, 13);
+      this.sizeLabel.TabIndex = 15;
+      this.sizeLabel.Text = "Size:";
+      // 
+      // projectionLabel
+      // 
+      this.projectionLabel.AutoSize = true;
+      this.projectionLabel.Location = new System.Drawing.Point(2, 12);
+      this.projectionLabel.Name = "projectionLabel";
+      this.projectionLabel.Size = new System.Drawing.Size(57, 13);
+      this.projectionLabel.TabIndex = 16;
+      this.projectionLabel.Text = "Projection:";
       // 
       // instanceMapChart
@@ -140,31 +203,35 @@
       this.instanceMapChart.Series.Add(series1);
       this.instanceMapChart.Series.Add(series2);
-      this.instanceMapChart.Size = new System.Drawing.Size(986, 698);
-      this.instanceMapChart.TabIndex = 0;
-      // 
-      // instancesTabPage
-      // 
-      this.instancesTabPage.Controls.Add(this.problemInstancesView);
-      this.instancesTabPage.Location = new System.Drawing.Point(4, 22);
-      this.instancesTabPage.Name = "instancesTabPage";
-      this.instancesTabPage.Padding = new System.Windows.Forms.Padding(3);
-      this.instancesTabPage.Size = new System.Drawing.Size(1044, 757);
-      this.instancesTabPage.TabIndex = 0;
-      this.instancesTabPage.Text = "Instances";
-      this.instancesTabPage.UseVisualStyleBackColor = true;
-      // 
-      // problemInstancesView
-      // 
-      this.problemInstancesView.Caption = "View";
-      this.problemInstancesView.Content = null;
-      this.problemInstancesView.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.problemInstancesView.Enabled = false;
-      this.problemInstancesView.Location = new System.Drawing.Point(3, 3);
-      this.problemInstancesView.Name = "problemInstancesView";
-      this.problemInstancesView.ReadOnly = false;
-      this.problemInstancesView.Size = new System.Drawing.Size(1038, 751);
-      this.problemInstancesView.TabIndex = 0;
-      this.problemInstancesView.ViewsLabelVisible = true;
-      this.problemInstancesView.ViewType = null;
+      this.instanceMapChart.Size = new System.Drawing.Size(841, 692);
+      this.instanceMapChart.TabIndex = 12;
+      // 
+      // sizeComboBox
+      // 
+      this.sizeComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
+      this.sizeComboBox.FormattingEnabled = true;
+      this.sizeComboBox.Location = new System.Drawing.Point(300, 6);
+      this.sizeComboBox.Name = "sizeComboBox";
+      this.sizeComboBox.Size = new System.Drawing.Size(273, 21);
+      this.sizeComboBox.TabIndex = 13;
+      // 
+      // projectionComboBox
+      // 
+      this.projectionComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
+      this.projectionComboBox.FormattingEnabled = true;
+      this.projectionComboBox.Location = new System.Drawing.Point(65, 6);
+      this.projectionComboBox.Name = "projectionComboBox";
+      this.projectionComboBox.Size = new System.Drawing.Size(158, 21);
+      this.projectionComboBox.TabIndex = 14;
+      // 
+      // showCharacteristicsCheckBox
+      // 
+      this.showCharacteristicsCheckBox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
+      this.showCharacteristicsCheckBox.Appearance = System.Windows.Forms.Appearance.Button;
+      this.showCharacteristicsCheckBox.Location = new System.Drawing.Point(818, 4);
+      this.showCharacteristicsCheckBox.Name = "showCharacteristicsCheckBox";
+      this.showCharacteristicsCheckBox.Size = new System.Drawing.Size(26, 23);
+      this.showCharacteristicsCheckBox.TabIndex = 18;
+      this.showCharacteristicsCheckBox.Text = "Detail";
+      this.showCharacteristicsCheckBox.UseVisualStyleBackColor = true;
       // 
       // UnderstandingProblemInstanceView
@@ -175,10 +242,12 @@
       this.Name = "UnderstandingProblemInstanceView";
       this.Size = new System.Drawing.Size(1000, 760);
-      this.Controls.SetChildIndex(this.problemInstancesTabControl, 0);
       this.problemInstancesTabControl.ResumeLayout(false);
       this.mapTabPage.ResumeLayout(false);
-      this.mapTabPage.PerformLayout();
+      this.instancesTabPage.ResumeLayout(false);
+      this.mapSplitContainer.Panel1.ResumeLayout(false);
+      this.mapSplitContainer.Panel1.PerformLayout();
+      ((System.ComponentModel.ISupportInitialize)(this.mapSplitContainer)).EndInit();
+      this.mapSplitContainer.ResumeLayout(false);
       ((System.ComponentModel.ISupportInitialize)(this.instanceMapChart)).EndInit();
-      this.instancesTabPage.ResumeLayout(false);
       this.ResumeLayout(false);
 
@@ -187,11 +256,16 @@
     #endregion
 
-    private System.Windows.Forms.Label projectionLabel;
-    private System.Windows.Forms.ComboBox projectionComboBox;
     private MainForm.WindowsForms.DragOverTabControl problemInstancesTabControl;
     private System.Windows.Forms.TabPage mapTabPage;
-    private Visualization.ChartControlsExtensions.EnhancedChart instanceMapChart;
     private System.Windows.Forms.TabPage instancesTabPage;
     private MainForm.WindowsForms.ViewHost problemInstancesView;
+    private System.Windows.Forms.SplitContainer mapSplitContainer;
+    private System.Windows.Forms.CheckBox showCharacteristicsCheckBox;
+    private System.Windows.Forms.CheckBox invPropCheckBox;
+    private System.Windows.Forms.Label sizeLabel;
+    private System.Windows.Forms.Label projectionLabel;
+    private Visualization.ChartControlsExtensions.EnhancedChart instanceMapChart;
+    private System.Windows.Forms.ComboBox sizeComboBox;
+    private System.Windows.Forms.ComboBox projectionComboBox;
   }
 }
Index: branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Views/UnderstandingProblemInstanceView.cs
===================================================================
--- branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Views/UnderstandingProblemInstanceView.cs	(revision 13750)
+++ branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Views/UnderstandingProblemInstanceView.cs	(revision 13751)
@@ -20,4 +20,5 @@
 #endregion
 
+using HeuristicLab.Core;
 using HeuristicLab.MainForm;
 using HeuristicLab.OptimizationExpertSystem.Common;
@@ -31,5 +32,7 @@
   [View("Understanding Problem Instance")]
   [Content(typeof(KnowledgeCenter), IsDefaultView = false)]
-  public partial class UnderstandingProblemInstanceView : KnowledgeCenterViewBase {
+  public sealed partial class UnderstandingProblemInstanceView : KnowledgeCenterViewBase {
+    private bool SuppressEvents { get; set; }
+
     public UnderstandingProblemInstanceView() {
       InitializeComponent();
@@ -45,4 +48,5 @@
         problemInstancesView.Content = Content.ProblemInstances;
         UpdateProjectionComboBox();
+        UpdateSizeComboBox();
       }
     }
@@ -58,13 +62,39 @@
       if (Content.ProblemInstances.UpdateOfRunsInProgress) return;
       UpdateProjectionComboBox();
+      UpdateSizeComboBox();
+      UpdateProjection();
+    }
+    #endregion
+
+    private void UpdateProjectionComboBox() {
+      try {
+        SuppressEvents = true;
+        var selected = projectionComboBox.SelectedIndex >= 0 ? (string)projectionComboBox.SelectedItem : null;
+        projectionComboBox.Items.Clear();
+        foreach (var str in GetProjections()) {
+          projectionComboBox.Items.Add(str);
+          if (selected == str) projectionComboBox.SelectedItem = str;
+        }
+        if (selected == null && projectionComboBox.Items.Count > 0)
+          projectionComboBox.SelectedIndex = 0;
+      } finally { SuppressEvents = false; }
     }
 
-    protected override void OnDownloadEnded() {
-      base.OnDownloadEnded();
-      UpdateProjectionComboBox();
+    private void UpdateSizeComboBox() {
+      try {
+        SuppressEvents = true;
+        var selected = sizeComboBox.SelectedIndex >= 0 ? (string)sizeComboBox.SelectedItem : null;
+        sizeComboBox.Items.Clear();
+        sizeComboBox.Items.Add(string.Empty);
+        foreach (var str in Content.ProblemInstances.ResultNames.Where(x => !(x.StartsWith("Projection.") && (x.EndsWith(".X") || x.EndsWith(".Y"))))) {
+          sizeComboBox.Items.Add(str);
+          if (selected == str) sizeComboBox.SelectedItem = str;
+        }
+        if (selected == null && sizeComboBox.Items.Count > 0)
+          sizeComboBox.SelectedIndex = 0;
+      } finally { SuppressEvents = false; }
     }
-    #endregion
     
-    public IEnumerable<string> GetProjections() {
+    private IEnumerable<string> GetProjections() {
       return Content.ProblemInstances
         .SelectMany(x => x.Results.Where(y => Regex.IsMatch(y.Key, "^Projection[.].*[.][XY]$")))
@@ -73,8 +103,34 @@
     }
 
-    public void ProjectProblemInstances(Series instancesSeries, Series currentInstanceSeries, string projection) {
+    private void UpdateProjection() {
+      if (InvokeRequired) { Invoke((Action)UpdateProjection); return; }
+
+      var instancesSeries = instanceMapChart.Series["InstancesSeries"];
+      var currentInstanceSeries = instanceMapChart.Series["CurrentInstanceSeries"];
+
+      if (projectionComboBox.SelectedIndex < 0) {
+        instancesSeries.Points.Clear();
+        currentInstanceSeries.Points.Clear();
+        return;
+      }
+
+      var projection = (string)projectionComboBox.SelectedItem;
+      var size = sizeComboBox.SelectedIndex >= 0 ? (string)sizeComboBox.SelectedItem : string.Empty;
+
+      DoProjectProblemInstances(instancesSeries, currentInstanceSeries, projection, size, invPropCheckBox.Checked);
+    }
+
+    private void DoProjectProblemInstances(Series instancesSeries, Series currentInstanceSeries, string projection, string size, bool invProp) {
       instancesSeries.Points.Clear();
       currentInstanceSeries.Points.Clear();
 
+      double maxSize = 0, minSize = 0;
+      if (!string.IsNullOrEmpty(size)) {
+        var sizes = Content.ProblemInstances.Where(x => x.Results.ContainsKey(size)).Select(x => x.Results[size]).OfType<Data.DoubleValue>().Where(x => !double.IsNaN(x.Value)).ToList();
+        if (sizes.Count > 0) {
+          maxSize = sizes.Max(x => x.Value);
+          minSize = sizes.Min(x => x.Value);
+        }
+      }
       foreach (var run in Content.ProblemInstances) {
         var xKey = "Projection." + projection + ".X";
@@ -85,36 +141,39 @@
         var y = ((Data.DoubleValue)run.Results[yKey]).Value;
         var dataPoint = new DataPoint(x, y) {
-          Label = run.Name
+          Label = run.Name,
         };
-        instancesSeries.Points.Add(dataPoint);
-      }
+        IItem item;
+        if (maxSize > minSize && run.Results.TryGetValue(size, out item)) {
+          var dItem = item as Data.DoubleValue;
+          if (dItem != null) {
+            if (double.IsNaN(dItem.Value))
+              dataPoint.MarkerSize = 1;
+            else {
+              if (invProp) dataPoint.MarkerSize = (int)Math.Round(5 + 15 * (maxSize - dItem.Value) / (maxSize - minSize));
+              else dataPoint.MarkerSize = (int)Math.Round(5 + 15 * (dItem.Value - minSize) / (maxSize - minSize));
+            }
+          }
+        } else if (maxSize == minSize) {
+          dataPoint.MarkerSize = instancesSeries.MarkerSize;
+        } else dataPoint.MarkerSize = 1;
 
-      var curPoint = Content.ProjectCurrentInstance(projection);
-      if (curPoint != null) {
-        var dp = new DataPoint(curPoint.Item1, curPoint.Item2) {
-          Label = Content.Problem.Problem.Name
-        };
-        currentInstanceSeries.Points.Add(dp);
+        if (Content.IsCurrentInstance(run)) currentInstanceSeries.Points.Add(dataPoint);
+        else instancesSeries.Points.Add(dataPoint);
       }
     }
 
+    #region Control Event Handlers
     private void ProjectionComboBoxOnSelectedIndexChanged(object sender, EventArgs e) {
-      if (InvokeRequired) { Invoke((Action<object, EventArgs>)ProjectionComboBoxOnSelectedIndexChanged, sender, e); return; }
-      if (projectionComboBox.SelectedIndex < 0) return;
-      var projection = (string)projectionComboBox.SelectedItem;
-      var instancesSeries = instanceMapChart.Series["InstancesSeries"];
-      var currentInstanceSeries = instanceMapChart.Series["CurrentInstanceSeries"];
-
-      ProjectProblemInstances(instancesSeries, currentInstanceSeries, projection);
+      UpdateProjection();
     }
 
-    private void UpdateProjectionComboBox() {
-      projectionComboBox.Items.Clear();
-      foreach (var str in GetProjections()) {
-        projectionComboBox.Items.Add(str);
-      }
-      if (projectionComboBox.Items.Count > 0)
-        projectionComboBox.SelectedIndex = 0;
+    private void SizeComboBoxOnSelectedIndexChanged(object sender, EventArgs e) {
+      UpdateProjection();
     }
+
+    private void InvPropCheckBoxOnCheckedChanged(object sender, EventArgs e) {
+      UpdateProjection();
+    }
+    #endregion
   }
 }